package sort;

public class InsertionSort<T extends Comparable<? super T>> {

	private T[] data;

	private InsertionSort(T[] data) {
		this.data = data;
	}

	private void insert(int i) {
		if (i < data.length - 1) {
			if (data[i].compareTo(data[i + 1]) > 0) {
				T tmp = data[i];
				data[i] = data[i + 1];
				data[i + 1] = tmp;
				insert(i + 1);
			}
		}
	}

	public static <T extends Comparable<? super T>> void doSort(T[] a) {
		InsertionSort sort = new InsertionSort<T>(a);
		for (int i = sort.data.length - 2; i >= 0; --i) {
			sort.insert(i);
		}
	}
}
